Bug 1687217 - Review Request: ttyd - is a simple command-line tool for sharing terminal over the web
Summary: Review Request: ttyd - is a simple command-line tool for sharing terminal ove...
Keywords:
Status: CLOSED DUPLICATE of bug 1833612
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR FE-DEADREVIEW
TreeView+ depends on / blocked
 
Reported: 2019-03-11 00:16 UTC by Fernando Pereira dos Santos
Modified: 2020-05-09 04:37 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-09 04:37:44 UTC
Type: ---
zebob.m: fedora-review?


Attachments (Terms of Use)

Description Fernando Pereira dos Santos 2019-03-11 00:16:47 UTC
Spec URL: https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd.spec
SRPM URL: https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd-1.4.2-1.fc29.src.rpm
Description: ttyd is a simple command-line tool for sharing terminal over the web, inspired by GoTTY.
Fedora Account System Username: ferox

Comment 1 Robert-André Mauchin 🐧 2019-03-11 15:37:34 UTC
This is your first package, you'll need to find a sponsor.
Blocking FE-NEEDSPONSOR.

Comment 2 Robert-André Mauchin 🐧 2019-03-11 16:04:00 UTC
 - Simplify the Source0:

Source0: https://github.com/tsl0922/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

 - The LICENSE file must be included with %license not %doc

 - Split the description to stay under 80 characters per line:

ttyd.x86_64: E: description-line-too-long C ttyd is a simple command-line tool for sharing terminal over the web, inspired by GoTTY.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "Apache License
     (v2.0)", "GNU General Public License (v2)". 48 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/ttyd/review-ttyd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ttyd ,
     ttyd-debuginfo , ttyd-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ttyd-1.4.2-1.fc31.x86_64.rpm
          ttyd-debuginfo-1.4.2-1.fc31.x86_64.rpm
          ttyd-debugsource-1.4.2-1.fc31.x86_64.rpm
          ttyd-1.4.2-1.fc31.src.rpm
ttyd.x86_64: E: description-line-too-long C ttyd is a simple command-line tool for sharing terminal over the web, inspired by GoTTY.
ttyd.src: E: description-line-too-long C ttyd is a simple command-line tool for sharing terminal over the web, inspired by GoTTY.
4 packages and 0 specfiles checked; 2 errors, 0 warnings.

Comment 4 Jason Tibbitts 2019-03-26 21:06:06 UTC
This is very interesting; ttyd looks like it could be a reasonable replacement for shellinabox (which has kind of gone unmaintained for a while).  However it seems to me that the packaging is a bit barebones for something that I'd expect to provide a daemon.  Shouldn't it at least provide a systemd unit, or was your intent not to do so?  If the latter, how do you envision this package being used?

I haven't gone through the entire build process but I'm curious about what happens to the bundled javascript bits.  I guess it all ends up crammed into the pre-bompiled index.html and that gets compiled into the binary.  But I'm not sure if that code is xterm.js, is derived from xterm.js or is something else; if it's bundled, that needs to be indicated here with Provides: bundled(xterm.js) = 3.2.0 or whatever the version is.  And it appears to be pre-minimized, which causes its own issues about that needing to be built from source.  Frankly I don't know much about webpack or how this even gets built, but I'm not sure that what's in the ttyd source tarball is all that's actually needed to completely rebuild everything from source.

Another thing would be an selinux policy, but that's not at all required.  I managed to get one working for shellinabox but it has a somewhat different scope.

Comment 5 Robert-André Mauchin 🐧 2019-03-26 21:16:43 UTC
(In reply to Fernando Pereira dos Santos from comment #3)
> Fixed.
> 
> Spec URL: https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd.spec
> SRPM URL:
> https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd-1.4.2-2.fc29.src.rpm

Issue not addressed:

 - Simplify the Source0:

Source0: https://github.com/tsl0922/%{name}/archive/%{version}/%{name}-%{version}.tar.gz


Package is approved, but please fix this.

You  still need to find a sponsor: https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

Comment 6 Jason Tibbitts 2019-03-26 21:19:42 UTC
Erm, surely at least the bundling issue deserves a mention.

Comment 7 Robert-André Mauchin 🐧 2019-03-26 21:28:02 UTC
I did not notice the index.htl with minified JS in it. It would be nice to identify the source of it, especially the License: and add a bundled Provides for it as Jason said.

Comment 8 Robert-André Mauchin 🐧 2019-03-26 21:33:03 UTC
(In reply to Robert-André Mauchin from comment #7)
> I did not notice the index.htl with minified JS in it. It would be nice to
> identify the source of it, especially the License: and add a bundled
> Provides for it as Jason said.

The bundle seems to contain:

    "dependencies": {
        "bulma": "^0.6.1",
        "core-js": "^2.5.3",
        "fast-text-encoding": "^1.0.0",
        "xterm": "^3.12.0",
        "zmodem.js": "^0.1.7"
    },

Comment 9 Jason Tibbitts 2019-03-26 21:53:11 UTC
If fast-text-encoding is https://github.com/samthor/fast-text-encoding then that's Apache 2.0.  I think zmodem.js is also Apache 2.0 (https://github.com/FGasper/zmodemjs).  The others appear to be MIT.

Comment 10 Fernando Pereira dos Santos 2019-03-26 23:16:01 UTC
(In reply to Robert-André Mauchin from comment #5)
> (In reply to Fernando Pereira dos Santos from comment #3)
> > Fixed.
> > 
> > Spec URL: https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd.spec
> > SRPM URL:
> > https://ferox.fedorapeople.org/rpm-packages/ttyd/ttyd-1.4.2-2.fc29.src.rpm
> 
> Issue not addressed:
> 
>  - Simplify the Source0:
> 
> Source0:
> https://github.com/tsl0922/%{name}/archive/%{version}/%{name}-%{version}.tar.
> gz
> 
> 
> Package is approved, but please fix this.
> 
> You  still need to find a sponsor:
> https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

What you mean to simplify?

I'm following the official guide, using the %version macro: "Using %{version} in the SourceX: makes it easier for you to bump the version of a package, because most of the time you do not need to edit SourceX: when editing the spec file for the new package."

There is a lot of spec's samples around the web using Github url.

Comment 11 Robert-André Mauchin 🐧 2019-04-06 18:34:44 UTC
Source0: https://github.com/tsl0922/ttyd/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
vs
Source0: https://github.com/tsl0922/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

You don't have to use the #/ trick to rename the archive.

Comment 12 Itamar Reis Peixoto 2019-12-03 17:15:33 UTC
(In reply to Robert-André Mauchin from comment #11)

I would like to take over and finish this one packaging ttyd , sounds good to you ? will you review it ?

Comment 13 Robert-André Mauchin 🐧 2019-12-03 21:25:57 UTC
(In reply to Itamar Reis Peixoto from comment #12)
> (In reply to Robert-André Mauchin from comment #11)
> 
> I would like to take over and finish this one packaging ttyd , sounds good
> to you ? will you review it ?

If you plan to take over, you'll need to open another bug and mark this one as Duplicate and as FE:DEADREVIEW.

Comment 14 Itamar Reis Peixoto 2020-05-09 04:37:44 UTC

*** This bug has been marked as a duplicate of bug 1833612 ***


Note You need to log in before you can comment on or make changes to this bug.